import randomName from '../../../node_modules/.pnpm/@scaleway_random-name@4.0.2/node_modules/@scaleway/random-name/dist/index.js';
import { isJSONObject } from '../../../helpers/json.js';
import { unmarshalTimeSeries } from '../../../scw/custom-marshalling.js';
import { unmarshalDate, unmarshalArrayOfObject } from '../../../helpers/marshalling.js';

// This file was automatically generated. DO NOT EDIT.
// If you have any remark or suggestion do not hesitate to open an issue.
const unmarshalContactPointEmail = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ContactPointEmail' failed as data isn't a dictionary.`);
  }
  return {
    to: data.to
  };
};
const unmarshalContactPoint = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ContactPoint' failed as data isn't a dictionary.`);
  }
  return {
    email: data.email ? unmarshalContactPointEmail(data.email) : undefined
  };
};
const unmarshalGrafanaUser = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'GrafanaUser' failed as data isn't a dictionary.`);
  }
  return {
    id: data.id,
    login: data.login,
    password: data.password ? data.password : undefined,
    role: data.role
  };
};
const unmarshalTokenScopes = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'TokenScopes' failed as data isn't a dictionary.`);
  }
  return {
    queryLogs: data.query_logs,
    queryMetrics: data.query_metrics,
    queryTraces: data.query_traces,
    setupAlerts: data.setup_alerts,
    setupLogsRules: data.setup_logs_rules,
    setupMetricsRules: data.setup_metrics_rules,
    writeLogs: data.write_logs,
    writeMetrics: data.write_metrics,
    writeTraces: data.write_traces
  };
};
const unmarshalToken = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Token' failed as data isn't a dictionary.`);
  }
  return {
    createdAt: unmarshalDate(data.created_at),
    id: data.id,
    name: data.name,
    projectId: data.project_id,
    scopes: unmarshalTokenScopes(data.scopes),
    secretKey: data.secret_key ? data.secret_key : undefined,
    updatedAt: unmarshalDate(data.updated_at)
  };
};
const unmarshalPlan = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Plan' failed as data isn't a dictionary.`);
  }
  return {
    id: data.id,
    logsIngestionPrice: data.logs_ingestion_price,
    name: data.name,
    retentionLogsInterval: data.retention_logs_interval ? data.retention_logs_interval : undefined,
    retentionMetricsInterval: data.retention_metrics_interval ? data.retention_metrics_interval : undefined,
    retentionPrice: data.retention_price,
    sampleIngestionPrice: data.sample_ingestion_price
  };
};
const unmarshalCockpitEndpoints = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'CockpitEndpoints' failed as data isn't a dictionary.`);
  }
  return {
    alertmanagerUrl: data.alertmanager_url,
    grafanaUrl: data.grafana_url,
    logsUrl: data.logs_url,
    metricsUrl: data.metrics_url
  };
};
const unmarshalCockpit = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Cockpit' failed as data isn't a dictionary.`);
  }
  return {
    createdAt: unmarshalDate(data.created_at),
    endpoints: unmarshalCockpitEndpoints(data.endpoints),
    managedAlertsEnabled: data.managed_alerts_enabled,
    plan: unmarshalPlan(data.plan),
    projectId: data.project_id,
    status: data.status,
    updatedAt: unmarshalDate(data.updated_at)
  };
};
const unmarshalCockpitMetrics = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'CockpitMetrics' failed as data isn't a dictionary.`);
  }
  return {
    timeseries: unmarshalArrayOfObject(data.timeseries, unmarshalTimeSeries)
  };
};
const unmarshalDatasource = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Datasource' failed as data isn't a dictionary.`);
  }
  return {
    id: data.id,
    name: data.name,
    projectId: data.project_id,
    type: data.type,
    url: data.url
  };
};
const unmarshalListContactPointsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListContactPointsResponse' failed as data isn't a dictionary.`);
  }
  return {
    contactPoints: unmarshalArrayOfObject(data.contact_points, unmarshalContactPoint),
    hasAdditionalContactPoints: data.has_additional_contact_points,
    hasAdditionalReceivers: data.has_additional_receivers,
    totalCount: data.total_count
  };
};
const unmarshalListGrafanaUsersResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListGrafanaUsersResponse' failed as data isn't a dictionary.`);
  }
  return {
    grafanaUsers: unmarshalArrayOfObject(data.grafana_users, unmarshalGrafanaUser),
    totalCount: data.total_count
  };
};
const unmarshalListPlansResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListPlansResponse' failed as data isn't a dictionary.`);
  }
  return {
    plans: unmarshalArrayOfObject(data.plans, unmarshalPlan),
    totalCount: data.total_count
  };
};
const unmarshalListTokensResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListTokensResponse' failed as data isn't a dictionary.`);
  }
  return {
    tokens: unmarshalArrayOfObject(data.tokens, unmarshalToken),
    totalCount: data.total_count
  };
};
const unmarshalSelectPlanResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'SelectPlanResponse' failed as data isn't a dictionary.`);
  }
  return {};
};
const marshalActivateCockpitRequest = (request, defaults) => ({
  project_id: request.projectId ?? defaults.defaultProjectId
});
const marshalCreateContactPointRequest = (request, defaults) => ({
  contact_point: request.contactPoint,
  project_id: request.projectId ?? defaults.defaultProjectId
});
const marshalCreateDatasourceRequest = (request, defaults) => ({
  name: request.name,
  project_id: request.projectId ?? defaults.defaultProjectId,
  type: request.type
});
const marshalCreateGrafanaUserRequest = (request, defaults) => ({
  login: request.login,
  project_id: request.projectId ?? defaults.defaultProjectId,
  role: request.role
});
const marshalCreateTokenRequest = (request, defaults) => ({
  name: request.name || randomName('token'),
  project_id: request.projectId ?? defaults.defaultProjectId,
  scopes: request.scopes
});
const marshalDeactivateCockpitRequest = (request, defaults) => ({
  project_id: request.projectId ?? defaults.defaultProjectId
});
const marshalDeleteContactPointRequest = (request, defaults) => ({
  contact_point: request.contactPoint,
  project_id: request.projectId ?? defaults.defaultProjectId
});
const marshalDeleteGrafanaUserRequest = (request, defaults) => ({
  project_id: request.projectId ?? defaults.defaultProjectId
});
const marshalDisableManagedAlertsRequest = (request, defaults) => ({
  project_id: request.projectId ?? defaults.defaultProjectId
});
const marshalEnableManagedAlertsRequest = (request, defaults) => ({
  project_id: request.projectId ?? defaults.defaultProjectId
});
const marshalResetCockpitGrafanaRequest = (request, defaults) => ({
  project_id: request.projectId ?? defaults.defaultProjectId
});
const marshalResetGrafanaUserPasswordRequest = (request, defaults) => ({
  project_id: request.projectId ?? defaults.defaultProjectId
});
const marshalSelectPlanRequest = (request, defaults) => ({
  plan_id: request.planId,
  project_id: request.projectId ?? defaults.defaultProjectId
});
const marshalTriggerTestAlertRequest = (request, defaults) => ({
  project_id: request.projectId ?? defaults.defaultProjectId
});

export { marshalActivateCockpitRequest, marshalCreateContactPointRequest, marshalCreateDatasourceRequest, marshalCreateGrafanaUserRequest, marshalCreateTokenRequest, marshalDeactivateCockpitRequest, marshalDeleteContactPointRequest, marshalDeleteGrafanaUserRequest, marshalDisableManagedAlertsRequest, marshalEnableManagedAlertsRequest, marshalResetCockpitGrafanaRequest, marshalResetGrafanaUserPasswordRequest, marshalSelectPlanRequest, marshalTriggerTestAlertRequest, unmarshalCockpit, unmarshalCockpitMetrics, unmarshalContactPoint, unmarshalDatasource, unmarshalGrafanaUser, unmarshalListContactPointsResponse, unmarshalListGrafanaUsersResponse, unmarshalListPlansResponse, unmarshalListTokensResponse, unmarshalSelectPlanResponse, unmarshalToken };
