import randomName from '../../../node_modules/.pnpm/@scaleway_random-name@4.0.2/node_modules/@scaleway/random-name/dist/index.js';
import { isJSONObject } from '../../../helpers/json.js';
import { unmarshalDate, unmarshalMapOfObject, unmarshalArrayOfObject, resolveOneOf } from '../../../helpers/marshalling.js';

// This file was automatically generated. DO NOT EDIT.
// If you have any remark or suggestion do not hesitate to open an issue.
const unmarshalPrivateNIC = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'PrivateNIC' failed as data isn't a dictionary.`);
  }
  return {
    id: data.id,
    macAddress: data.mac_address,
    privateNetworkId: data.private_network_id,
    serverId: data.server_id,
    state: data.state,
    tags: data.tags
  };
};
const unmarshalVolumeSummary = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'VolumeSummary' failed as data isn't a dictionary.`);
  }
  return {
    id: data.id,
    name: data.name,
    size: data.size,
    volumeType: data.volume_type
  };
};
const unmarshalServerSummary = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ServerSummary' failed as data isn't a dictionary.`);
  }
  return {
    id: data.id,
    name: data.name
  };
};
const unmarshalVolume = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Volume' failed as data isn't a dictionary.`);
  }
  return {
    creationDate: unmarshalDate(data.creation_date),
    exportUri: data.export_uri ? data.export_uri : undefined,
    id: data.id,
    modificationDate: unmarshalDate(data.modification_date),
    name: data.name,
    organization: data.organization,
    project: data.project,
    server: unmarshalServerSummary(data.server),
    size: data.size,
    state: data.state,
    tags: data.tags,
    volumeType: data.volume_type,
    zone: data.zone
  };
};
const unmarshalBootscript = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Bootscript' failed as data isn't a dictionary.`);
  }
  return {
    arch: data.arch,
    bootcmdargs: data.bootcmdargs,
    default: data.default,
    dtb: data.dtb,
    id: data.id,
    initrd: data.initrd,
    kernel: data.kernel,
    organization: data.organization,
    project: data.project,
    public: data.public,
    title: data.title,
    zone: data.zone
  };
};
const unmarshalImage = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Image' failed as data isn't a dictionary.`);
  }
  return {
    arch: data.arch,
    creationDate: unmarshalDate(data.creation_date),
    defaultBootscript: data.default_bootscript ? unmarshalBootscript(data.default_bootscript) : undefined,
    extraVolumes: unmarshalMapOfObject(data.extra_volumes, unmarshalVolume),
    fromServer: data.from_server,
    id: data.id,
    modificationDate: unmarshalDate(data.modification_date),
    name: data.name,
    organization: data.organization,
    project: data.project,
    public: data.public,
    rootVolume: unmarshalVolumeSummary(data.root_volume),
    state: data.state,
    tags: data.tags,
    zone: data.zone
  };
};
const unmarshalCreateImageResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'CreateImageResponse' failed as data isn't a dictionary.`);
  }
  return {
    image: unmarshalImage(data.image)
  };
};
const unmarshalIp = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Ip' failed as data isn't a dictionary.`);
  }
  return {
    address: data.address,
    id: data.id,
    organization: data.organization,
    prefix: data.prefix,
    project: data.project,
    reverse: data.reverse ? data.reverse : undefined,
    server: unmarshalServerSummary(data.server),
    state: data.state,
    tags: data.tags,
    type: data.type,
    zone: data.zone
  };
};
const unmarshalCreateIpResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'CreateIpResponse' failed as data isn't a dictionary.`);
  }
  return {
    ip: unmarshalIp(data.ip)
  };
};
const unmarshalPlacementGroup = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'PlacementGroup' failed as data isn't a dictionary.`);
  }
  return {
    id: data.id,
    name: data.name,
    organization: data.organization,
    policyMode: data.policy_mode,
    policyRespected: data.policy_respected,
    policyType: data.policy_type,
    project: data.project,
    tags: data.tags,
    zone: data.zone
  };
};
const unmarshalCreatePlacementGroupResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'CreatePlacementGroupResponse' failed as data isn't a dictionary.`);
  }
  return {
    placementGroup: unmarshalPlacementGroup(data.placement_group)
  };
};
const unmarshalCreatePrivateNICResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'CreatePrivateNICResponse' failed as data isn't a dictionary.`);
  }
  return {
    privateNic: unmarshalPrivateNIC(data.private_nic)
  };
};
const unmarshalSecurityGroup = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'SecurityGroup' failed as data isn't a dictionary.`);
  }
  return {
    creationDate: unmarshalDate(data.creation_date),
    description: data.description,
    enableDefaultSecurity: data.enable_default_security,
    id: data.id,
    inboundDefaultPolicy: data.inbound_default_policy,
    modificationDate: unmarshalDate(data.modification_date),
    name: data.name,
    organization: data.organization,
    organizationDefault: data.organization_default ? data.organization_default : undefined,
    outboundDefaultPolicy: data.outbound_default_policy,
    project: data.project,
    projectDefault: data.project_default,
    servers: unmarshalArrayOfObject(data.servers, unmarshalServerSummary),
    state: data.state,
    stateful: data.stateful,
    tags: data.tags,
    zone: data.zone
  };
};
const unmarshalCreateSecurityGroupResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'CreateSecurityGroupResponse' failed as data isn't a dictionary.`);
  }
  return {
    securityGroup: unmarshalSecurityGroup(data.security_group)
  };
};
const unmarshalSecurityGroupRule = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'SecurityGroupRule' failed as data isn't a dictionary.`);
  }
  return {
    action: data.action,
    destPortFrom: data.dest_port_from ? data.dest_port_from : undefined,
    destPortTo: data.dest_port_to ? data.dest_port_to : undefined,
    direction: data.direction,
    editable: data.editable,
    id: data.id,
    ipRange: data.ip_range,
    position: data.position,
    protocol: data.protocol,
    zone: data.zone
  };
};
const unmarshalCreateSecurityGroupRuleResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'CreateSecurityGroupRuleResponse' failed as data isn't a dictionary.`);
  }
  return {
    rule: unmarshalSecurityGroupRule(data.rule)
  };
};
const unmarshalServerMaintenance = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ServerMaintenance' failed as data isn't a dictionary.`);
  }
  return {
    reason: data.reason
  };
};
const unmarshalSecurityGroupSummary = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'SecurityGroupSummary' failed as data isn't a dictionary.`);
  }
  return {
    id: data.id,
    name: data.name
  };
};
const unmarshalVolumeServer = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'VolumeServer' failed as data isn't a dictionary.`);
  }
  return {
    boot: data.boot,
    creationDate: unmarshalDate(data.creation_date),
    exportUri: data.export_uri,
    id: data.id,
    modificationDate: unmarshalDate(data.modification_date),
    name: data.name,
    organization: data.organization,
    project: data.project,
    server: unmarshalServerSummary(data.server),
    size: data.size,
    state: data.state,
    volumeType: data.volume_type,
    zone: data.zone
  };
};
const unmarshalServerIpv6 = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ServerIpv6' failed as data isn't a dictionary.`);
  }
  return {
    address: data.address,
    gateway: data.gateway,
    netmask: data.netmask
  };
};
const unmarshalServerLocation = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ServerLocation' failed as data isn't a dictionary.`);
  }
  return {
    clusterId: data.cluster_id,
    hypervisorId: data.hypervisor_id,
    nodeId: data.node_id,
    platformId: data.platform_id,
    zoneId: data.zone_id
  };
};
const unmarshalServerIp = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ServerIp' failed as data isn't a dictionary.`);
  }
  return {
    address: data.address,
    dynamic: data.dynamic,
    family: data.family,
    gateway: data.gateway,
    id: data.id,
    netmask: data.netmask,
    provisioningMode: data.provisioning_mode
  };
};
const unmarshalServer = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Server' failed as data isn't a dictionary.`);
  }
  return {
    allowedActions: data.allowed_actions,
    arch: data.arch,
    bootType: data.boot_type,
    bootscript: data.bootscript ? unmarshalBootscript(data.bootscript) : undefined,
    commercialType: data.commercial_type,
    creationDate: unmarshalDate(data.creation_date),
    dynamicIpRequired: data.dynamic_ip_required,
    enableIpv6: data.enable_ipv6,
    hostname: data.hostname,
    id: data.id,
    image: unmarshalImage(data.image),
    ipv6: unmarshalServerIpv6(data.ipv6),
    location: unmarshalServerLocation(data.location),
    macAddress: data.mac_address,
    maintenances: unmarshalArrayOfObject(data.maintenances, unmarshalServerMaintenance),
    modificationDate: unmarshalDate(data.modification_date),
    name: data.name,
    organization: data.organization,
    placementGroup: unmarshalPlacementGroup(data.placement_group),
    privateIp: data.private_ip ? data.private_ip : undefined,
    privateNics: unmarshalArrayOfObject(data.private_nics, unmarshalPrivateNIC),
    project: data.project,
    protected: data.protected,
    publicIp: unmarshalServerIp(data.public_ip),
    publicIps: unmarshalArrayOfObject(data.public_ips, unmarshalServerIp),
    routedIpEnabled: data.routed_ip_enabled,
    securityGroup: unmarshalSecurityGroupSummary(data.security_group),
    state: data.state,
    stateDetail: data.state_detail,
    tags: data.tags,
    volumes: unmarshalMapOfObject(data.volumes, unmarshalVolumeServer),
    zone: data.zone
  };
};
const unmarshalCreateServerResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'CreateServerResponse' failed as data isn't a dictionary.`);
  }
  return {
    server: unmarshalServer(data.server)
  };
};
const unmarshalTask = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Task' failed as data isn't a dictionary.`);
  }
  return {
    description: data.description,
    hrefFrom: data.href_from,
    hrefResult: data.href_result,
    id: data.id,
    progress: data.progress,
    startedAt: unmarshalDate(data.started_at),
    status: data.status,
    terminatedAt: unmarshalDate(data.terminated_at),
    zone: data.zone
  };
};
const unmarshalSnapshotBaseVolume = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'SnapshotBaseVolume' failed as data isn't a dictionary.`);
  }
  return {
    id: data.id,
    name: data.name
  };
};
const unmarshalSnapshot = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Snapshot' failed as data isn't a dictionary.`);
  }
  return {
    baseVolume: unmarshalSnapshotBaseVolume(data.base_volume),
    creationDate: unmarshalDate(data.creation_date),
    errorReason: data.error_reason ? data.error_reason : undefined,
    id: data.id,
    modificationDate: unmarshalDate(data.modification_date),
    name: data.name,
    organization: data.organization,
    project: data.project,
    size: data.size,
    state: data.state,
    tags: data.tags,
    volumeType: data.volume_type,
    zone: data.zone
  };
};
const unmarshalCreateSnapshotResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'CreateSnapshotResponse' failed as data isn't a dictionary.`);
  }
  return {
    snapshot: unmarshalSnapshot(data.snapshot),
    task: unmarshalTask(data.task)
  };
};
const unmarshalCreateVolumeResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'CreateVolumeResponse' failed as data isn't a dictionary.`);
  }
  return {
    volume: unmarshalVolume(data.volume)
  };
};
const unmarshalExportSnapshotResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ExportSnapshotResponse' failed as data isn't a dictionary.`);
  }
  return {
    task: unmarshalTask(data.task)
  };
};
const unmarshalGetBootscriptResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'GetBootscriptResponse' failed as data isn't a dictionary.`);
  }
  return {
    bootscript: unmarshalBootscript(data.bootscript)
  };
};
const unmarshalDashboard = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Dashboard' failed as data isn't a dictionary.`);
  }
  return {
    imagesCount: data.images_count,
    ipsCount: data.ips_count,
    ipsUnused: data.ips_unused,
    placementGroupsCount: data.placement_groups_count,
    privateNicsCount: data.private_nics_count,
    runningServersCount: data.running_servers_count,
    securityGroupsCount: data.security_groups_count,
    serversByTypes: data.servers_by_types,
    serversCount: data.servers_count,
    snapshotsCount: data.snapshots_count,
    volumesBSsdCount: data.volumes_b_ssd_count,
    volumesBSsdTotalSize: data.volumes_b_ssd_total_size,
    volumesCount: data.volumes_count,
    volumesLSsdCount: data.volumes_l_ssd_count,
    volumesLSsdTotalSize: data.volumes_l_ssd_total_size
  };
};
const unmarshalGetDashboardResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'GetDashboardResponse' failed as data isn't a dictionary.`);
  }
  return {
    dashboard: unmarshalDashboard(data.dashboard)
  };
};
const unmarshalGetImageResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'GetImageResponse' failed as data isn't a dictionary.`);
  }
  return {
    image: unmarshalImage(data.image)
  };
};
const unmarshalGetIpResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'GetIpResponse' failed as data isn't a dictionary.`);
  }
  return {
    ip: unmarshalIp(data.ip)
  };
};
const unmarshalGetPlacementGroupResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'GetPlacementGroupResponse' failed as data isn't a dictionary.`);
  }
  return {
    placementGroup: unmarshalPlacementGroup(data.placement_group)
  };
};
const unmarshalPlacementGroupServer = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'PlacementGroupServer' failed as data isn't a dictionary.`);
  }
  return {
    id: data.id,
    name: data.name,
    policyRespected: data.policy_respected
  };
};
const unmarshalGetPlacementGroupServersResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'GetPlacementGroupServersResponse' failed as data isn't a dictionary.`);
  }
  return {
    servers: unmarshalArrayOfObject(data.servers, unmarshalPlacementGroupServer)
  };
};
const unmarshalGetPrivateNICResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'GetPrivateNICResponse' failed as data isn't a dictionary.`);
  }
  return {
    privateNic: unmarshalPrivateNIC(data.private_nic)
  };
};
const unmarshalGetSecurityGroupResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'GetSecurityGroupResponse' failed as data isn't a dictionary.`);
  }
  return {
    securityGroup: unmarshalSecurityGroup(data.security_group)
  };
};
const unmarshalGetSecurityGroupRuleResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'GetSecurityGroupRuleResponse' failed as data isn't a dictionary.`);
  }
  return {
    rule: unmarshalSecurityGroupRule(data.rule)
  };
};
const unmarshalGetServerResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'GetServerResponse' failed as data isn't a dictionary.`);
  }
  return {
    server: unmarshalServer(data.server)
  };
};
const unmarshalGetServerTypesAvailabilityResponseAvailability = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'GetServerTypesAvailabilityResponseAvailability' failed as data isn't a dictionary.`);
  }
  return {
    availability: data.availability
  };
};
const unmarshalGetServerTypesAvailabilityResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'GetServerTypesAvailabilityResponse' failed as data isn't a dictionary.`);
  }
  return {
    servers: unmarshalMapOfObject(data.servers, unmarshalGetServerTypesAvailabilityResponseAvailability),
    totalCount: data.total_count
  };
};
const unmarshalGetSnapshotResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'GetSnapshotResponse' failed as data isn't a dictionary.`);
  }
  return {
    snapshot: unmarshalSnapshot(data.snapshot)
  };
};
const unmarshalGetVolumeResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'GetVolumeResponse' failed as data isn't a dictionary.`);
  }
  return {
    volume: unmarshalVolume(data.volume)
  };
};
const unmarshalListBootscriptsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListBootscriptsResponse' failed as data isn't a dictionary.`);
  }
  return {
    bootscripts: unmarshalArrayOfObject(data.bootscripts, unmarshalBootscript),
    totalCount: data.total_count
  };
};
const unmarshalListImagesResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListImagesResponse' failed as data isn't a dictionary.`);
  }
  return {
    images: unmarshalArrayOfObject(data.images, unmarshalImage),
    totalCount: data.total_count
  };
};
const unmarshalListIpsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListIpsResponse' failed as data isn't a dictionary.`);
  }
  return {
    ips: unmarshalArrayOfObject(data.ips, unmarshalIp),
    totalCount: data.total_count
  };
};
const unmarshalListPlacementGroupsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListPlacementGroupsResponse' failed as data isn't a dictionary.`);
  }
  return {
    placementGroups: unmarshalArrayOfObject(data.placement_groups, unmarshalPlacementGroup),
    totalCount: data.total_count
  };
};
const unmarshalListPrivateNICsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListPrivateNICsResponse' failed as data isn't a dictionary.`);
  }
  return {
    privateNics: unmarshalArrayOfObject(data.private_nics, unmarshalPrivateNIC),
    totalCount: data.total_count
  };
};
const unmarshalListSecurityGroupRulesResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListSecurityGroupRulesResponse' failed as data isn't a dictionary.`);
  }
  return {
    rules: unmarshalArrayOfObject(data.rules, unmarshalSecurityGroupRule),
    totalCount: data.total_count
  };
};
const unmarshalListSecurityGroupsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListSecurityGroupsResponse' failed as data isn't a dictionary.`);
  }
  return {
    securityGroups: unmarshalArrayOfObject(data.security_groups, unmarshalSecurityGroup),
    totalCount: data.total_count
  };
};
const unmarshalListServerActionsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListServerActionsResponse' failed as data isn't a dictionary.`);
  }
  return {
    actions: data.actions
  };
};
const unmarshalListServerUserDataResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListServerUserDataResponse' failed as data isn't a dictionary.`);
  }
  return {
    userData: data.user_data
  };
};
const unmarshalListServersResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListServersResponse' failed as data isn't a dictionary.`);
  }
  return {
    servers: unmarshalArrayOfObject(data.servers, unmarshalServer),
    totalCount: data.total_count
  };
};
const unmarshalServerTypeCapabilities = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ServerTypeCapabilities' failed as data isn't a dictionary.`);
  }
  return {
    blockStorage: data.block_storage ? data.block_storage : undefined,
    bootTypes: data.boot_types
  };
};
const unmarshalServerTypeNetworkInterface = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ServerTypeNetworkInterface' failed as data isn't a dictionary.`);
  }
  return {
    internalBandwidth: data.internal_bandwidth ? data.internal_bandwidth : undefined,
    internetBandwidth: data.internet_bandwidth ? data.internet_bandwidth : undefined
  };
};
const unmarshalServerTypeNetwork = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ServerTypeNetwork' failed as data isn't a dictionary.`);
  }
  return {
    interfaces: unmarshalArrayOfObject(data.interfaces, unmarshalServerTypeNetworkInterface),
    ipv6Support: data.ipv6_support,
    sumInternalBandwidth: data.sum_internal_bandwidth ? data.sum_internal_bandwidth : undefined,
    sumInternetBandwidth: data.sum_internet_bandwidth ? data.sum_internet_bandwidth : undefined
  };
};
const unmarshalServerTypeVolumeConstraintSizes = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ServerTypeVolumeConstraintSizes' failed as data isn't a dictionary.`);
  }
  return {
    maxSize: data.max_size,
    minSize: data.min_size
  };
};
const unmarshalServerTypeVolumeConstraintsByType = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ServerTypeVolumeConstraintsByType' failed as data isn't a dictionary.`);
  }
  return {
    lSsd: unmarshalServerTypeVolumeConstraintSizes(data.l_ssd)
  };
};
const unmarshalServerType = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ServerType' failed as data isn't a dictionary.`);
  }
  return {
    altNames: data.alt_names,
    arch: data.arch,
    baremetal: data.baremetal,
    capabilities: unmarshalServerTypeCapabilities(data.capabilities),
    gpu: data.gpu ? data.gpu : undefined,
    hourlyPrice: data.hourly_price,
    monthlyPrice: data.monthly_price ? data.monthly_price : undefined,
    ncpus: data.ncpus,
    network: unmarshalServerTypeNetwork(data.network),
    perVolumeConstraint: unmarshalServerTypeVolumeConstraintsByType(data.per_volume_constraint),
    ram: data.ram,
    scratchStorageMaxSize: data.scratch_storage_max_size ? data.scratch_storage_max_size : undefined,
    volumesConstraint: unmarshalServerTypeVolumeConstraintSizes(data.volumes_constraint)
  };
};
const unmarshalListServersTypesResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListServersTypesResponse' failed as data isn't a dictionary.`);
  }
  return {
    servers: unmarshalMapOfObject(data.servers, unmarshalServerType),
    totalCount: data.total_count
  };
};
const unmarshalListSnapshotsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListSnapshotsResponse' failed as data isn't a dictionary.`);
  }
  return {
    snapshots: unmarshalArrayOfObject(data.snapshots, unmarshalSnapshot),
    totalCount: data.total_count
  };
};
const unmarshalListVolumesResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListVolumesResponse' failed as data isn't a dictionary.`);
  }
  return {
    totalCount: data.total_count,
    volumes: unmarshalArrayOfObject(data.volumes, unmarshalVolume)
  };
};
const unmarshalVolumeTypeConstraints = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'VolumeTypeConstraints' failed as data isn't a dictionary.`);
  }
  return {
    max: data.max,
    min: data.min
  };
};
const unmarshalVolumeTypeCapabilities = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'VolumeTypeCapabilities' failed as data isn't a dictionary.`);
  }
  return {
    snapshot: data.snapshot
  };
};
const unmarshalVolumeType = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'VolumeType' failed as data isn't a dictionary.`);
  }
  return {
    capabilities: unmarshalVolumeTypeCapabilities(data.capabilities),
    constraints: unmarshalVolumeTypeConstraints(data.constraints),
    displayName: data.display_name
  };
};
const unmarshalListVolumesTypesResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListVolumesTypesResponse' failed as data isn't a dictionary.`);
  }
  return {
    totalCount: data.total_count,
    volumes: unmarshalMapOfObject(data.volumes, unmarshalVolumeType)
  };
};
const unmarshalMigrationPlan = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'MigrationPlan' failed as data isn't a dictionary.`);
  }
  return {
    snapshots: unmarshalArrayOfObject(data.snapshots, unmarshalSnapshot),
    validationKey: data.validation_key,
    volume: unmarshalVolume(data.volume)
  };
};
const unmarshalServerActionResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ServerActionResponse' failed as data isn't a dictionary.`);
  }
  return {
    task: unmarshalTask(data.task)
  };
};
const unmarshalSetImageResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'SetImageResponse' failed as data isn't a dictionary.`);
  }
  return {
    image: unmarshalImage(data.image)
  };
};
const unmarshalSetPlacementGroupResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'SetPlacementGroupResponse' failed as data isn't a dictionary.`);
  }
  return {
    placementGroup: unmarshalPlacementGroup(data.placement_group)
  };
};
const unmarshalSetPlacementGroupServersResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'SetPlacementGroupServersResponse' failed as data isn't a dictionary.`);
  }
  return {
    servers: unmarshalArrayOfObject(data.servers, unmarshalPlacementGroupServer)
  };
};
const unmarshalSetSecurityGroupResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'SetSecurityGroupResponse' failed as data isn't a dictionary.`);
  }
  return {
    securityGroup: unmarshalSecurityGroup(data.security_group)
  };
};
const unmarshalSetSecurityGroupRuleResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'SetSecurityGroupRuleResponse' failed as data isn't a dictionary.`);
  }
  return {
    rule: unmarshalSecurityGroupRule(data.rule)
  };
};
const unmarshalSetSecurityGroupRulesResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'SetSecurityGroupRulesResponse' failed as data isn't a dictionary.`);
  }
  return {
    rules: unmarshalArrayOfObject(data.rules, unmarshalSecurityGroupRule)
  };
};
const unmarshalSetServerResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'SetServerResponse' failed as data isn't a dictionary.`);
  }
  return {
    server: unmarshalServer(data.server)
  };
};
const unmarshalSetSnapshotResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'SetSnapshotResponse' failed as data isn't a dictionary.`);
  }
  return {
    snapshot: unmarshalSnapshot(data.snapshot)
  };
};
const unmarshalUpdateIpResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'UpdateIpResponse' failed as data isn't a dictionary.`);
  }
  return {
    ip: unmarshalIp(data.ip)
  };
};
const unmarshalUpdatePlacementGroupResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'UpdatePlacementGroupResponse' failed as data isn't a dictionary.`);
  }
  return {
    placementGroup: unmarshalPlacementGroup(data.placement_group)
  };
};
const unmarshalUpdatePlacementGroupServersResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'UpdatePlacementGroupServersResponse' failed as data isn't a dictionary.`);
  }
  return {
    servers: unmarshalArrayOfObject(data.servers, unmarshalPlacementGroupServer)
  };
};
const unmarshalUpdateServerResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'UpdateServerResponse' failed as data isn't a dictionary.`);
  }
  return {
    server: unmarshalServer(data.server)
  };
};
const unmarshalUpdateVolumeResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'UpdateVolumeResponse' failed as data isn't a dictionary.`);
  }
  return {
    volume: unmarshalVolume(data.volume)
  };
};
const marshalApplyBlockMigrationRequest = (request, defaults) => ({
  validation_key: request.validationKey,
  ...resolveOneOf([{
    param: 'snapshot_id',
    value: request.snapshotId
  }, {
    param: 'volume_id',
    value: request.volumeId
  }])
});
const marshalCreateImageRequest = (request, defaults) => ({
  arch: request.arch,
  default_bootscript: request.defaultBootscript,
  extra_volumes: request.extraVolumes,
  name: request.name || randomName('img'),
  public: request.public,
  root_volume: request.rootVolume,
  tags: request.tags,
  ...resolveOneOf([{
    param: 'organization',
    value: request.organization
  }, {
    param: 'project',
    value: request.project
  }])
});
const marshalCreateIpRequest = (request, defaults) => ({
  server: request.server,
  tags: request.tags,
  type: request.type,
  ...resolveOneOf([{
    param: 'organization',
    value: request.organization
  }, {
    param: 'project',
    value: request.project
  }])
});
const marshalCreatePlacementGroupRequest = (request, defaults) => ({
  name: request.name || randomName('pg'),
  policy_mode: request.policyMode,
  policy_type: request.policyType,
  tags: request.tags,
  ...resolveOneOf([{
    param: 'organization',
    value: request.organization
  }, {
    param: 'project',
    value: request.project
  }])
});
const marshalCreatePrivateNICRequest = (request, defaults) => ({
  ip_ids: request.ipIds,
  private_network_id: request.privateNetworkId,
  tags: request.tags
});
const marshalCreateSecurityGroupRequest = (request, defaults) => ({
  description: request.description,
  enable_default_security: request.enableDefaultSecurity,
  inbound_default_policy: request.inboundDefaultPolicy,
  name: request.name || randomName('sg'),
  outbound_default_policy: request.outboundDefaultPolicy,
  stateful: request.stateful,
  tags: request.tags,
  ...resolveOneOf([{
    param: 'organization',
    value: request.organization
  }, {
    param: 'project',
    value: request.project
  }]),
  ...resolveOneOf([{
    param: 'organization_default',
    value: request.organizationDefault
  }, {
    param: 'project_default',
    value: request.projectDefault
  }])
});
const marshalCreateSecurityGroupRuleRequest = (request, defaults) => ({
  action: request.action,
  dest_port_from: request.destPortFrom,
  dest_port_to: request.destPortTo,
  direction: request.direction,
  editable: request.editable,
  ip_range: request.ipRange,
  position: request.position,
  protocol: request.protocol
});
const marshalCreateServerRequest = (request, defaults) => ({
  boot_type: request.bootType,
  bootscript: request.bootscript,
  commercial_type: request.commercialType,
  dynamic_ip_required: request.dynamicIpRequired,
  enable_ipv6: request.enableIpv6,
  image: request.image,
  name: request.name || randomName('srv'),
  placement_group: request.placementGroup,
  public_ip: request.publicIp,
  public_ips: request.publicIps,
  routed_ip_enabled: request.routedIpEnabled,
  security_group: request.securityGroup,
  tags: request.tags,
  volumes: request.volumes,
  ...resolveOneOf([{
    param: 'organization',
    value: request.organization
  }, {
    param: 'project',
    value: request.project
  }])
});
const marshalCreateSnapshotRequest = (request, defaults) => ({
  bucket: request.bucket,
  key: request.key,
  name: request.name || randomName('snp'),
  size: request.size,
  tags: request.tags,
  volume_id: request.volumeId,
  volume_type: request.volumeType,
  ...resolveOneOf([{
    param: 'organization',
    value: request.organization
  }, {
    param: 'project',
    value: request.project
  }])
});
const marshalCreateVolumeRequest = (request, defaults) => ({
  name: request.name || randomName('vol'),
  tags: request.tags,
  volume_type: request.volumeType,
  ...resolveOneOf([{
    param: 'organization',
    value: request.organization
  }, {
    param: 'project',
    value: request.project
  }]),
  ...resolveOneOf([{
    param: 'base_snapshot',
    value: request.baseSnapshot
  }, {
    param: 'base_volume',
    value: request.baseVolume
  }, {
    param: 'size',
    value: request.size
  }])
});
const marshalExportSnapshotRequest = (request, defaults) => ({
  bucket: request.bucket,
  key: request.key
});
const marshalPlanBlockMigrationRequest = (request, defaults) => ({
  ...resolveOneOf([{
    param: 'snapshot_id',
    value: request.snapshotId
  }, {
    param: 'volume_id',
    value: request.volumeId
  }])
});
const marshalServerActionRequest = (request, defaults) => ({
  action: request.action,
  name: request.name,
  volumes: request.volumes
});
const marshalSetImageRequest = (request, defaults) => ({
  arch: request.arch,
  creation_date: request.creationDate,
  default_bootscript: request.defaultBootscript,
  extra_volumes: request.extraVolumes,
  from_server: request.fromServer,
  modification_date: request.modificationDate,
  name: request.name,
  organization: request.organization ?? defaults.defaultOrganizationId,
  project: request.project ?? defaults.defaultProjectId,
  public: request.public,
  root_volume: request.rootVolume,
  state: request.state,
  tags: request.tags
});
const marshalSetPlacementGroupRequest = (request, defaults) => ({
  name: request.name,
  organization: request.organization ?? defaults.defaultOrganizationId,
  policy_mode: request.policyMode,
  policy_type: request.policyType,
  project: request.project ?? defaults.defaultProjectId,
  tags: request.tags
});
const marshalSetPlacementGroupServersRequest = (request, defaults) => ({
  servers: request.servers
});
const marshalSetSecurityGroupRequest = (request, defaults) => ({
  creation_date: request.creationDate,
  description: request.description,
  enable_default_security: request.enableDefaultSecurity,
  inbound_default_policy: request.inboundDefaultPolicy,
  modification_date: request.modificationDate,
  name: request.name,
  organization: request.organization ?? defaults.defaultOrganizationId,
  organization_default: request.organizationDefault,
  outbound_default_policy: request.outboundDefaultPolicy,
  project: request.project ?? defaults.defaultProjectId,
  project_default: request.projectDefault,
  servers: request.servers,
  stateful: request.stateful,
  tags: request.tags
});
const marshalSetSecurityGroupRuleRequest = (request, defaults) => ({
  action: request.action,
  dest_port_from: request.destPortFrom,
  dest_port_to: request.destPortTo,
  direction: request.direction,
  editable: request.editable,
  id: request.id,
  ip_range: request.ipRange,
  position: request.position,
  protocol: request.protocol
});
const marshalSetSecurityGroupRulesRequest = (request, defaults) => ({
  rules: request.rules
});
const marshalSetServerRequest = (request, defaults) => ({
  allowed_actions: request.allowedActions,
  arch: request.arch,
  boot_type: request.bootType,
  bootscript: request.bootscript,
  commercial_type: request.commercialType,
  creation_date: request.creationDate,
  dynamic_ip_required: request.dynamicIpRequired,
  enable_ipv6: request.enableIpv6,
  hostname: request.hostname,
  image: request.image,
  ipv6: request.ipv6,
  location: request.location,
  maintenances: request.maintenances,
  modification_date: request.modificationDate,
  name: request.name,
  organization: request.organization ?? defaults.defaultOrganizationId,
  placement_group: request.placementGroup,
  private_ip: request.privateIp,
  private_nics: request.privateNics,
  project: request.project ?? defaults.defaultProjectId,
  protected: request.protected,
  public_ip: request.publicIp,
  public_ips: request.publicIps,
  routed_ip_enabled: request.routedIpEnabled,
  security_group: request.securityGroup,
  state: request.state,
  state_detail: request.stateDetail,
  tags: request.tags,
  volumes: request.volumes
});
const marshalSetSnapshotRequest = (request, defaults) => ({
  base_volume: request.baseVolume,
  creation_date: request.creationDate,
  id: request.id,
  modification_date: request.modificationDate,
  name: request.name,
  organization: request.organization ?? defaults.defaultOrganizationId,
  project: request.project ?? defaults.defaultProjectId,
  size: request.size,
  state: request.state,
  tags: request.tags,
  volume_type: request.volumeType
});
const marshalUpdateIpRequest = (request, defaults) => ({
  reverse: request.reverse,
  server: request.server,
  tags: request.tags,
  type: request.type
});
const marshalUpdatePlacementGroupRequest = (request, defaults) => ({
  name: request.name,
  policy_mode: request.policyMode,
  policy_type: request.policyType,
  tags: request.tags
});
const marshalUpdatePlacementGroupServersRequest = (request, defaults) => ({
  servers: request.servers
});
const marshalUpdatePrivateNICRequest = (request, defaults) => ({
  tags: request.tags
});
const marshalUpdateServerRequest = (request, defaults) => ({
  boot_type: request.bootType,
  bootscript: request.bootscript,
  commercial_type: request.commercialType,
  dynamic_ip_required: request.dynamicIpRequired,
  enable_ipv6: request.enableIpv6,
  name: request.name,
  placement_group: request.placementGroup,
  private_nics: request.privateNics,
  protected: request.protected,
  public_ips: request.publicIps,
  routed_ip_enabled: request.routedIpEnabled,
  security_group: request.securityGroup,
  tags: request.tags,
  volumes: request.volumes
});
const marshalUpdateVolumeRequest = (request, defaults) => ({
  name: request.name,
  size: request.size,
  tags: request.tags
});

export { marshalApplyBlockMigrationRequest, marshalCreateImageRequest, marshalCreateIpRequest, marshalCreatePlacementGroupRequest, marshalCreatePrivateNICRequest, marshalCreateSecurityGroupRequest, marshalCreateSecurityGroupRuleRequest, marshalCreateServerRequest, marshalCreateSnapshotRequest, marshalCreateVolumeRequest, marshalExportSnapshotRequest, marshalPlanBlockMigrationRequest, marshalServerActionRequest, marshalSetImageRequest, marshalSetPlacementGroupRequest, marshalSetPlacementGroupServersRequest, marshalSetSecurityGroupRequest, marshalSetSecurityGroupRuleRequest, marshalSetSecurityGroupRulesRequest, marshalSetServerRequest, marshalSetSnapshotRequest, marshalUpdateIpRequest, marshalUpdatePlacementGroupRequest, marshalUpdatePlacementGroupServersRequest, marshalUpdatePrivateNICRequest, marshalUpdateServerRequest, marshalUpdateVolumeRequest, unmarshalCreateImageResponse, unmarshalCreateIpResponse, unmarshalCreatePlacementGroupResponse, unmarshalCreatePrivateNICResponse, unmarshalCreateSecurityGroupResponse, unmarshalCreateSecurityGroupRuleResponse, unmarshalCreateServerResponse, unmarshalCreateSnapshotResponse, unmarshalCreateVolumeResponse, unmarshalExportSnapshotResponse, unmarshalGetBootscriptResponse, unmarshalGetDashboardResponse, unmarshalGetImageResponse, unmarshalGetIpResponse, unmarshalGetPlacementGroupResponse, unmarshalGetPlacementGroupServersResponse, unmarshalGetPrivateNICResponse, unmarshalGetSecurityGroupResponse, unmarshalGetSecurityGroupRuleResponse, unmarshalGetServerResponse, unmarshalGetServerTypesAvailabilityResponse, unmarshalGetSnapshotResponse, unmarshalGetVolumeResponse, unmarshalListBootscriptsResponse, unmarshalListImagesResponse, unmarshalListIpsResponse, unmarshalListPlacementGroupsResponse, unmarshalListPrivateNICsResponse, unmarshalListSecurityGroupRulesResponse, unmarshalListSecurityGroupsResponse, unmarshalListServerActionsResponse, unmarshalListServerUserDataResponse, unmarshalListServersResponse, unmarshalListServersTypesResponse, unmarshalListSnapshotsResponse, unmarshalListVolumesResponse, unmarshalListVolumesTypesResponse, unmarshalMigrationPlan, unmarshalPrivateNIC, unmarshalServerActionResponse, unmarshalSetImageResponse, unmarshalSetPlacementGroupResponse, unmarshalSetPlacementGroupServersResponse, unmarshalSetSecurityGroupResponse, unmarshalSetSecurityGroupRuleResponse, unmarshalSetSecurityGroupRulesResponse, unmarshalSetServerResponse, unmarshalSetSnapshotResponse, unmarshalUpdateIpResponse, unmarshalUpdatePlacementGroupResponse, unmarshalUpdatePlacementGroupServersResponse, unmarshalUpdateServerResponse, unmarshalUpdateVolumeResponse };
