import { isJSONObject } from '../../../helpers/json.js';
import { unmarshalDate, unmarshalArrayOfObject } from '../../../helpers/marshalling.js';

// This file was automatically generated. DO NOT EDIT.
// If you have any remark or suggestion do not hesitate to open an issue.
const unmarshalPinInfo = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'PinInfo' failed as data isn't a dictionary.`);
  }
  return {
    id: data.id ? data.id : undefined,
    progress: data.progress ? data.progress : undefined,
    size: data.size ? data.size : undefined,
    statusDetails: data.status_details,
    url: data.url ? data.url : undefined
  };
};
const unmarshalPinCIDMeta = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'PinCIDMeta' failed as data isn't a dictionary.`);
  }
  return {
    id: data.id ? data.id : undefined
  };
};
const unmarshalPinCID = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'PinCID' failed as data isn't a dictionary.`);
  }
  return {
    cid: data.cid ? data.cid : undefined,
    meta: unmarshalPinCIDMeta(data.meta),
    name: data.name ? data.name : undefined,
    origins: data.origins
  };
};
const unmarshalPin = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Pin' failed as data isn't a dictionary.`);
  }
  return {
    cid: unmarshalPinCID(data.cid),
    createdAt: unmarshalDate(data.created_at),
    delegates: data.delegates,
    info: unmarshalPinInfo(data.info),
    pinId: data.pin_id,
    status: data.status
  };
};
const unmarshalVolume = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Volume' failed as data isn't a dictionary.`);
  }
  return {
    countPin: data.count_pin,
    createdAt: unmarshalDate(data.created_at),
    id: data.id,
    name: data.name,
    projectId: data.project_id,
    region: data.region,
    size: data.size ? data.size : undefined,
    tags: data.tags,
    updatedAt: unmarshalDate(data.updated_at)
  };
};
const unmarshalListPinsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListPinsResponse' failed as data isn't a dictionary.`);
  }
  return {
    pins: unmarshalArrayOfObject(data.pins, unmarshalPin),
    totalCount: data.total_count
  };
};
const unmarshalListVolumesResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListVolumesResponse' failed as data isn't a dictionary.`);
  }
  return {
    totalCount: data.total_count,
    volumes: unmarshalArrayOfObject(data.volumes, unmarshalVolume)
  };
};
const unmarshalReplacePinResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ReplacePinResponse' failed as data isn't a dictionary.`);
  }
  return {
    pin: unmarshalPin(data.pin)
  };
};
const marshalCreatePinByCIDRequest = (request, defaults) => ({
  cid: request.cid,
  name: request.name,
  origins: request.origins,
  pin_options: request.pinOptions,
  volume_id: request.volumeId
});
const marshalCreatePinByURLRequest = (request, defaults) => ({
  name: request.name,
  pin_options: request.pinOptions,
  url: request.url,
  volume_id: request.volumeId
});
const marshalCreateVolumeRequest = (request, defaults) => ({
  name: request.name,
  project_id: request.projectId ?? defaults.defaultProjectId
});
const marshalReplacePinRequest = (request, defaults) => ({
  cid: request.cid,
  name: request.name,
  origins: request.origins,
  pin_options: request.pinOptions,
  volume_id: request.volumeId
});
const marshalUpdateVolumeRequest = (request, defaults) => ({
  name: request.name,
  tags: request.tags
});

export { marshalCreatePinByCIDRequest, marshalCreatePinByURLRequest, marshalCreateVolumeRequest, marshalReplacePinRequest, marshalUpdateVolumeRequest, unmarshalListPinsResponse, unmarshalListVolumesResponse, unmarshalPin, unmarshalReplacePinResponse, unmarshalVolume };
