import randomName from '../../../node_modules/.pnpm/@scaleway_random-name@4.0.2/node_modules/@scaleway/random-name/dist/index.js';
import { isJSONObject } from '../../../helpers/json.js';
import { unmarshalDate, unmarshalArrayOfObject, resolveOneOf } from '../../../helpers/marshalling.js';

// This file was automatically generated. DO NOT EDIT.
// If you have any remark or suggestion do not hesitate to open an issue.
const unmarshalIp = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Ip' failed as data isn't a dictionary.`);
  }
  return {
    id: data.id,
    ipAddress: data.ip_address,
    lbId: data.lb_id ? data.lb_id : undefined,
    organizationId: data.organization_id,
    projectId: data.project_id,
    region: data.region ? data.region : undefined,
    reverse: data.reverse,
    zone: data.zone
  };
};
const unmarshalSubscriberWebhookConfig = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'SubscriberWebhookConfig' failed as data isn't a dictionary.`);
  }
  return {
    uri: data.uri
  };
};
const unmarshalSubscriberEmailConfig = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'SubscriberEmailConfig' failed as data isn't a dictionary.`);
  }
  return {
    email: data.email
  };
};
const unmarshalSubscriber = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Subscriber' failed as data isn't a dictionary.`);
  }
  return {
    emailConfig: data.email_config ? unmarshalSubscriberEmailConfig(data.email_config) : undefined,
    id: data.id,
    name: data.name,
    webhookConfig: data.webhook_config ? unmarshalSubscriberWebhookConfig(data.webhook_config) : undefined
  };
};
const unmarshalHealthCheckHttpsConfig = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'HealthCheckHttpsConfig' failed as data isn't a dictionary.`);
  }
  return {
    code: data.code ? data.code : undefined,
    hostHeader: data.host_header,
    method: data.method,
    sni: data.sni,
    uri: data.uri
  };
};
const unmarshalHealthCheckHttpConfig = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'HealthCheckHttpConfig' failed as data isn't a dictionary.`);
  }
  return {
    code: data.code ? data.code : undefined,
    hostHeader: data.host_header,
    method: data.method,
    uri: data.uri
  };
};
const unmarshalHealthCheckRedisConfig = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'HealthCheckRedisConfig' failed as data isn't a dictionary.`);
  }
  return {};
};
const unmarshalHealthCheckLdapConfig = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'HealthCheckLdapConfig' failed as data isn't a dictionary.`);
  }
  return {};
};
const unmarshalHealthCheckPgsqlConfig = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'HealthCheckPgsqlConfig' failed as data isn't a dictionary.`);
  }
  return {
    user: data.user
  };
};
const unmarshalHealthCheckMysqlConfig = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'HealthCheckMysqlConfig' failed as data isn't a dictionary.`);
  }
  return {
    user: data.user
  };
};
const unmarshalHealthCheckTcpConfig = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'HealthCheckTcpConfig' failed as data isn't a dictionary.`);
  }
  return {};
};
const unmarshalHealthCheck = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'HealthCheck' failed as data isn't a dictionary.`);
  }
  return {
    checkDelay: data.check_delay ? data.check_delay : undefined,
    checkMaxRetries: data.check_max_retries,
    checkSendProxy: data.check_send_proxy,
    checkTimeout: data.check_timeout ? data.check_timeout : undefined,
    httpConfig: data.http_config ? unmarshalHealthCheckHttpConfig(data.http_config) : undefined,
    httpsConfig: data.https_config ? unmarshalHealthCheckHttpsConfig(data.https_config) : undefined,
    ldapConfig: data.ldap_config ? unmarshalHealthCheckLdapConfig(data.ldap_config) : undefined,
    mysqlConfig: data.mysql_config ? unmarshalHealthCheckMysqlConfig(data.mysql_config) : undefined,
    pgsqlConfig: data.pgsql_config ? unmarshalHealthCheckPgsqlConfig(data.pgsql_config) : undefined,
    port: data.port,
    redisConfig: data.redis_config ? unmarshalHealthCheckRedisConfig(data.redis_config) : undefined,
    tcpConfig: data.tcp_config ? unmarshalHealthCheckTcpConfig(data.tcp_config) : undefined,
    transientCheckDelay: data.transient_check_delay ? data.transient_check_delay : undefined
  };
};
const unmarshalInstance = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Instance' failed as data isn't a dictionary.`);
  }
  return {
    createdAt: unmarshalDate(data.created_at),
    id: data.id,
    ipAddress: data.ip_address,
    region: data.region ? data.region : undefined,
    status: data.status,
    updatedAt: unmarshalDate(data.updated_at),
    zone: data.zone
  };
};
const unmarshalLb = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Lb' failed as data isn't a dictionary.`);
  }
  return {
    backendCount: data.backend_count,
    createdAt: unmarshalDate(data.created_at),
    description: data.description,
    frontendCount: data.frontend_count,
    id: data.id,
    instances: unmarshalArrayOfObject(data.instances, unmarshalInstance),
    ip: unmarshalArrayOfObject(data.ip, unmarshalIp),
    name: data.name,
    organizationId: data.organization_id,
    privateNetworkCount: data.private_network_count,
    projectId: data.project_id,
    region: data.region ? data.region : undefined,
    routeCount: data.route_count,
    sslCompatibilityLevel: data.ssl_compatibility_level,
    status: data.status,
    subscriber: unmarshalSubscriber(data.subscriber),
    tags: data.tags,
    type: data.type,
    updatedAt: unmarshalDate(data.updated_at),
    zone: data.zone
  };
};
const unmarshalBackend = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Backend' failed as data isn't a dictionary.`);
  }
  return {
    createdAt: unmarshalDate(data.created_at),
    failoverHost: data.failover_host ? data.failover_host : undefined,
    forwardPort: data.forward_port,
    forwardPortAlgorithm: data.forward_port_algorithm,
    forwardProtocol: data.forward_protocol,
    healthCheck: unmarshalHealthCheck(data.health_check),
    id: data.id,
    ignoreSslServerVerify: data.ignore_ssl_server_verify ? data.ignore_ssl_server_verify : undefined,
    lb: unmarshalLb(data.lb),
    maxConnections: data.max_connections ? data.max_connections : undefined,
    maxRetries: data.max_retries ? data.max_retries : undefined,
    name: data.name,
    onMarkedDownAction: data.on_marked_down_action,
    pool: data.pool,
    proxyProtocol: data.proxy_protocol,
    redispatchAttemptCount: data.redispatch_attempt_count ? data.redispatch_attempt_count : undefined,
    sendProxyV2: data.send_proxy_v2 ? data.send_proxy_v2 : undefined,
    sslBridging: data.ssl_bridging ? data.ssl_bridging : undefined,
    stickySessions: data.sticky_sessions,
    stickySessionsCookieName: data.sticky_sessions_cookie_name,
    timeoutConnect: data.timeout_connect ? data.timeout_connect : undefined,
    timeoutQueue: data.timeout_queue ? data.timeout_queue : undefined,
    timeoutServer: data.timeout_server ? data.timeout_server : undefined,
    timeoutTunnel: data.timeout_tunnel ? data.timeout_tunnel : undefined,
    updatedAt: unmarshalDate(data.updated_at)
  };
};
const unmarshalCertificate = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Certificate' failed as data isn't a dictionary.`);
  }
  return {
    commonName: data.common_name,
    createdAt: unmarshalDate(data.created_at),
    fingerprint: data.fingerprint,
    id: data.id,
    lb: unmarshalLb(data.lb),
    name: data.name,
    notValidAfter: unmarshalDate(data.not_valid_after),
    notValidBefore: unmarshalDate(data.not_valid_before),
    status: data.status,
    statusDetails: data.status_details ? data.status_details : undefined,
    subjectAlternativeName: data.subject_alternative_name,
    type: data.type,
    updatedAt: unmarshalDate(data.updated_at)
  };
};
const unmarshalFrontend = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Frontend' failed as data isn't a dictionary.`);
  }
  return {
    backend: unmarshalBackend(data.backend),
    certificate: data.certificate ? unmarshalCertificate(data.certificate) : undefined,
    certificateIds: data.certificate_ids,
    createdAt: unmarshalDate(data.created_at),
    enableHttp3: data.enable_http3,
    id: data.id,
    inboundPort: data.inbound_port,
    lb: unmarshalLb(data.lb),
    name: data.name,
    timeoutClient: data.timeout_client ? data.timeout_client : undefined,
    updatedAt: unmarshalDate(data.updated_at)
  };
};
const unmarshalAclActionRedirect = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'AclActionRedirect' failed as data isn't a dictionary.`);
  }
  return {
    code: data.code ? data.code : undefined,
    target: data.target,
    type: data.type
  };
};
const unmarshalAclAction = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'AclAction' failed as data isn't a dictionary.`);
  }
  return {
    redirect: unmarshalAclActionRedirect(data.redirect),
    type: data.type
  };
};
const unmarshalAclMatch = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'AclMatch' failed as data isn't a dictionary.`);
  }
  return {
    httpFilter: data.http_filter,
    httpFilterOption: data.http_filter_option ? data.http_filter_option : undefined,
    httpFilterValue: data.http_filter_value,
    invert: data.invert,
    ipSubnet: data.ip_subnet
  };
};
const unmarshalAcl = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Acl' failed as data isn't a dictionary.`);
  }
  return {
    action: unmarshalAclAction(data.action),
    createdAt: unmarshalDate(data.created_at),
    description: data.description,
    frontend: unmarshalFrontend(data.frontend),
    id: data.id,
    index: data.index,
    match: unmarshalAclMatch(data.match),
    name: data.name,
    updatedAt: unmarshalDate(data.updated_at)
  };
};
const unmarshalPrivateNetworkIpamConfig = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'PrivateNetworkIpamConfig' failed as data isn't a dictionary.`);
  }
  return {};
};
const unmarshalPrivateNetworkDHCPConfig = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'PrivateNetworkDHCPConfig' failed as data isn't a dictionary.`);
  }
  return {
    ipId: data.ip_id ? data.ip_id : undefined
  };
};
const unmarshalPrivateNetworkStaticConfig = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'PrivateNetworkStaticConfig' failed as data isn't a dictionary.`);
  }
  return {
    ipAddress: data.ip_address ? data.ip_address : undefined
  };
};
const unmarshalPrivateNetwork = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'PrivateNetwork' failed as data isn't a dictionary.`);
  }
  return {
    createdAt: unmarshalDate(data.created_at),
    dhcpConfig: data.dhcp_config ? unmarshalPrivateNetworkDHCPConfig(data.dhcp_config) : undefined,
    ipamConfig: data.ipam_config ? unmarshalPrivateNetworkIpamConfig(data.ipam_config) : undefined,
    ipamIds: data.ipam_ids,
    lb: unmarshalLb(data.lb),
    privateNetworkId: data.private_network_id,
    staticConfig: data.static_config ? unmarshalPrivateNetworkStaticConfig(data.static_config) : undefined,
    status: data.status,
    updatedAt: unmarshalDate(data.updated_at)
  };
};
const unmarshalRouteMatch = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'RouteMatch' failed as data isn't a dictionary.`);
  }
  return {
    hostHeader: data.host_header ? data.host_header : undefined,
    sni: data.sni ? data.sni : undefined
  };
};
const unmarshalRoute = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Route' failed as data isn't a dictionary.`);
  }
  return {
    backendId: data.backend_id,
    createdAt: unmarshalDate(data.created_at),
    frontendId: data.frontend_id,
    id: data.id,
    match: unmarshalRouteMatch(data.match),
    updatedAt: unmarshalDate(data.updated_at)
  };
};
const unmarshalBackendServerStats = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'BackendServerStats' failed as data isn't a dictionary.`);
  }
  return {
    backendId: data.backend_id,
    instanceId: data.instance_id,
    ip: data.ip,
    lastHealthCheckStatus: data.last_health_check_status,
    serverState: data.server_state,
    serverStateChangedAt: unmarshalDate(data.server_state_changed_at)
  };
};
const unmarshalLbStats = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'LbStats' failed as data isn't a dictionary.`);
  }
  return {
    backendServersStats: unmarshalArrayOfObject(data.backend_servers_stats, unmarshalBackendServerStats)
  };
};
const unmarshalListAclResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListAclResponse' failed as data isn't a dictionary.`);
  }
  return {
    acls: unmarshalArrayOfObject(data.acls, unmarshalAcl),
    totalCount: data.total_count
  };
};
const unmarshalListBackendStatsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListBackendStatsResponse' failed as data isn't a dictionary.`);
  }
  return {
    backendServersStats: unmarshalArrayOfObject(data.backend_servers_stats, unmarshalBackendServerStats),
    totalCount: data.total_count
  };
};
const unmarshalListBackendsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListBackendsResponse' failed as data isn't a dictionary.`);
  }
  return {
    backends: unmarshalArrayOfObject(data.backends, unmarshalBackend),
    totalCount: data.total_count
  };
};
const unmarshalListCertificatesResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListCertificatesResponse' failed as data isn't a dictionary.`);
  }
  return {
    certificates: unmarshalArrayOfObject(data.certificates, unmarshalCertificate),
    totalCount: data.total_count
  };
};
const unmarshalListFrontendsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListFrontendsResponse' failed as data isn't a dictionary.`);
  }
  return {
    frontends: unmarshalArrayOfObject(data.frontends, unmarshalFrontend),
    totalCount: data.total_count
  };
};
const unmarshalListIpsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListIpsResponse' failed as data isn't a dictionary.`);
  }
  return {
    ips: unmarshalArrayOfObject(data.ips, unmarshalIp),
    totalCount: data.total_count
  };
};
const unmarshalListLbPrivateNetworksResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListLbPrivateNetworksResponse' failed as data isn't a dictionary.`);
  }
  return {
    privateNetwork: unmarshalArrayOfObject(data.private_network, unmarshalPrivateNetwork),
    totalCount: data.total_count
  };
};
const unmarshalLbType = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'LbType' failed as data isn't a dictionary.`);
  }
  return {
    description: data.description,
    name: data.name,
    region: data.region ? data.region : undefined,
    stockStatus: data.stock_status,
    zone: data.zone
  };
};
const unmarshalListLbTypesResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListLbTypesResponse' failed as data isn't a dictionary.`);
  }
  return {
    lbTypes: unmarshalArrayOfObject(data.lb_types, unmarshalLbType),
    totalCount: data.total_count
  };
};
const unmarshalListLbsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListLbsResponse' failed as data isn't a dictionary.`);
  }
  return {
    lbs: unmarshalArrayOfObject(data.lbs, unmarshalLb),
    totalCount: data.total_count
  };
};
const unmarshalListRoutesResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListRoutesResponse' failed as data isn't a dictionary.`);
  }
  return {
    routes: unmarshalArrayOfObject(data.routes, unmarshalRoute),
    totalCount: data.total_count
  };
};
const unmarshalListSubscriberResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListSubscriberResponse' failed as data isn't a dictionary.`);
  }
  return {
    subscribers: unmarshalArrayOfObject(data.subscribers, unmarshalSubscriber),
    totalCount: data.total_count
  };
};
const unmarshalSetAclsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'SetAclsResponse' failed as data isn't a dictionary.`);
  }
  return {
    acls: unmarshalArrayOfObject(data.acls, unmarshalAcl),
    totalCount: data.total_count
  };
};
const marshalAddBackendServersRequest = (request, defaults) => ({
  server_ip: request.serverIp
});
const marshalAttachPrivateNetworkRequest = (request, defaults) => ({
  ...resolveOneOf([{
    param: 'dhcp_config',
    value: request.dhcpConfig
  }, {
    param: 'ipam_config',
    value: request.ipamConfig
  }, {
    param: 'static_config',
    value: request.staticConfig
  }])
});
const marshalCreateAclRequest = (request, defaults) => ({
  action: request.action,
  description: request.description,
  index: request.index,
  match: request.match,
  name: request.name || randomName('acl')
});
const marshalCreateBackendRequest = (request, defaults) => ({
  failover_host: request.failoverHost,
  forward_port: request.forwardPort,
  forward_port_algorithm: request.forwardPortAlgorithm,
  forward_protocol: request.forwardProtocol,
  health_check: request.healthCheck,
  ignore_ssl_server_verify: request.ignoreSslServerVerify,
  max_connections: request.maxConnections,
  max_retries: request.maxRetries,
  name: request.name || randomName('lbb'),
  on_marked_down_action: request.onMarkedDownAction,
  proxy_protocol: request.proxyProtocol,
  redispatch_attempt_count: request.redispatchAttemptCount,
  send_proxy_v2: request.sendProxyV2,
  server_ip: request.serverIp,
  ssl_bridging: request.sslBridging,
  sticky_sessions: request.stickySessions,
  sticky_sessions_cookie_name: request.stickySessionsCookieName,
  timeout_connect: request.timeoutConnect,
  timeout_queue: request.timeoutQueue,
  timeout_server: request.timeoutServer,
  timeout_tunnel: request.timeoutTunnel
});
const marshalCreateCertificateRequest = (request, defaults) => ({
  name: request.name || randomName('certificate'),
  ...resolveOneOf([{
    param: 'custom_certificate',
    value: request.customCertificate
  }, {
    param: 'letsencrypt',
    value: request.letsencrypt
  }])
});
const marshalCreateFrontendRequest = (request, defaults) => ({
  backend_id: request.backendId,
  certificate_id: request.certificateId,
  certificate_ids: request.certificateIds,
  enable_http3: request.enableHttp3,
  inbound_port: request.inboundPort,
  name: request.name || randomName('lbf'),
  timeout_client: request.timeoutClient
});
const marshalCreateIpRequest = (request, defaults) => ({
  reverse: request.reverse,
  ...resolveOneOf([{
    param: 'organization_id',
    value: request.organizationId
  }, {
    param: 'project_id',
    value: request.projectId
  }])
});
const marshalCreateLbRequest = (request, defaults) => ({
  assign_flexible_ip: request.assignFlexibleIp,
  description: request.description,
  ip_id: request.ipId,
  name: request.name || randomName('lb'),
  ssl_compatibility_level: request.sslCompatibilityLevel,
  tags: request.tags,
  type: request.type,
  ...resolveOneOf([{
    param: 'organization_id',
    value: request.organizationId
  }, {
    param: 'project_id',
    value: request.projectId
  }])
});
const marshalCreateRouteRequest = (request, defaults) => ({
  backend_id: request.backendId,
  frontend_id: request.frontendId,
  match: request.match
});
const marshalCreateSubscriberRequest = (request, defaults) => ({
  name: request.name,
  ...resolveOneOf([{
    param: 'organization_id',
    value: request.organizationId
  }, {
    param: 'project_id',
    value: request.projectId
  }]),
  ...resolveOneOf([{
    param: 'email_config',
    value: request.emailConfig
  }, {
    param: 'webhook_config',
    value: request.webhookConfig
  }])
});
const marshalMigrateLbRequest = (request, defaults) => ({
  type: request.type
});
const marshalRemoveBackendServersRequest = (request, defaults) => ({
  server_ip: request.serverIp
});
const marshalSetBackendServersRequest = (request, defaults) => ({
  server_ip: request.serverIp
});
const marshalSubscribeToLbRequest = (request, defaults) => ({
  subscriber_id: request.subscriberId
});
const marshalUpdateAclRequest = (request, defaults) => ({
  action: request.action,
  description: request.description,
  index: request.index,
  match: request.match,
  name: request.name
});
const marshalUpdateBackendRequest = (request, defaults) => ({
  failover_host: request.failoverHost,
  forward_port: request.forwardPort,
  forward_port_algorithm: request.forwardPortAlgorithm,
  forward_protocol: request.forwardProtocol,
  ignore_ssl_server_verify: request.ignoreSslServerVerify,
  max_connections: request.maxConnections,
  max_retries: request.maxRetries,
  name: request.name,
  on_marked_down_action: request.onMarkedDownAction,
  proxy_protocol: request.proxyProtocol,
  redispatch_attempt_count: request.redispatchAttemptCount,
  send_proxy_v2: request.sendProxyV2,
  ssl_bridging: request.sslBridging,
  sticky_sessions: request.stickySessions,
  sticky_sessions_cookie_name: request.stickySessionsCookieName,
  timeout_connect: request.timeoutConnect,
  timeout_queue: request.timeoutQueue,
  timeout_server: request.timeoutServer,
  timeout_tunnel: request.timeoutTunnel
});
const marshalUpdateCertificateRequest = (request, defaults) => ({
  name: request.name
});
const marshalUpdateFrontendRequest = (request, defaults) => ({
  backend_id: request.backendId,
  certificate_id: request.certificateId,
  certificate_ids: request.certificateIds,
  enable_http3: request.enableHttp3,
  inbound_port: request.inboundPort,
  name: request.name,
  timeout_client: request.timeoutClient
});
const marshalUpdateHealthCheckRequest = (request, defaults) => ({
  check_delay: request.checkDelay,
  check_max_retries: request.checkMaxRetries,
  check_send_proxy: request.checkSendProxy,
  check_timeout: request.checkTimeout,
  port: request.port,
  transient_check_delay: request.transientCheckDelay,
  ...resolveOneOf([{
    param: 'http_config',
    value: request.httpConfig
  }, {
    param: 'https_config',
    value: request.httpsConfig
  }, {
    param: 'ldap_config',
    value: request.ldapConfig
  }, {
    param: 'mysql_config',
    value: request.mysqlConfig
  }, {
    param: 'pgsql_config',
    value: request.pgsqlConfig
  }, {
    param: 'redis_config',
    value: request.redisConfig
  }, {
    param: 'tcp_config',
    value: request.tcpConfig
  }])
});
const marshalUpdateIpRequest = (request, defaults) => ({
  reverse: request.reverse
});
const marshalUpdateLbRequest = (request, defaults) => ({
  description: request.description,
  name: request.name,
  ssl_compatibility_level: request.sslCompatibilityLevel,
  tags: request.tags
});
const marshalUpdateRouteRequest = (request, defaults) => ({
  backend_id: request.backendId,
  match: request.match
});
const marshalUpdateSubscriberRequest = (request, defaults) => ({
  name: request.name,
  ...resolveOneOf([{
    param: 'email_config',
    value: request.emailConfig
  }, {
    param: 'webhook_config',
    value: request.webhookConfig
  }])
});
const marshalZonedApiAddBackendServersRequest = (request, defaults) => ({
  server_ip: request.serverIp
});
const marshalZonedApiAttachPrivateNetworkRequest = (request, defaults) => ({
  ...resolveOneOf([{
    param: 'dhcp_config',
    value: request.dhcpConfig
  }, {
    param: 'ipam_config',
    value: request.ipamConfig
  }, {
    param: 'static_config',
    value: request.staticConfig
  }])
});
const marshalZonedApiCreateAclRequest = (request, defaults) => ({
  action: request.action,
  description: request.description,
  index: request.index,
  match: request.match,
  name: request.name || randomName('acl')
});
const marshalZonedApiCreateBackendRequest = (request, defaults) => ({
  failover_host: request.failoverHost,
  forward_port: request.forwardPort,
  forward_port_algorithm: request.forwardPortAlgorithm,
  forward_protocol: request.forwardProtocol,
  health_check: request.healthCheck,
  ignore_ssl_server_verify: request.ignoreSslServerVerify,
  max_connections: request.maxConnections,
  max_retries: request.maxRetries,
  name: request.name || randomName('lbb'),
  on_marked_down_action: request.onMarkedDownAction,
  proxy_protocol: request.proxyProtocol,
  redispatch_attempt_count: request.redispatchAttemptCount,
  send_proxy_v2: request.sendProxyV2,
  server_ip: request.serverIp,
  ssl_bridging: request.sslBridging,
  sticky_sessions: request.stickySessions,
  sticky_sessions_cookie_name: request.stickySessionsCookieName,
  timeout_connect: request.timeoutConnect,
  timeout_queue: request.timeoutQueue,
  timeout_server: request.timeoutServer,
  timeout_tunnel: request.timeoutTunnel
});
const marshalZonedApiCreateCertificateRequest = (request, defaults) => ({
  name: request.name || randomName('certificate'),
  ...resolveOneOf([{
    param: 'custom_certificate',
    value: request.customCertificate
  }, {
    param: 'letsencrypt',
    value: request.letsencrypt
  }])
});
const marshalZonedApiCreateFrontendRequest = (request, defaults) => ({
  backend_id: request.backendId,
  certificate_id: request.certificateId,
  certificate_ids: request.certificateIds,
  enable_http3: request.enableHttp3,
  inbound_port: request.inboundPort,
  name: request.name || randomName('lbf'),
  timeout_client: request.timeoutClient
});
const marshalZonedApiCreateIpRequest = (request, defaults) => ({
  reverse: request.reverse,
  ...resolveOneOf([{
    param: 'organization_id',
    value: request.organizationId
  }, {
    param: 'project_id',
    value: request.projectId
  }])
});
const marshalZonedApiCreateLbRequest = (request, defaults) => ({
  assign_flexible_ip: request.assignFlexibleIp,
  description: request.description,
  ip_id: request.ipId,
  name: request.name || randomName('lb'),
  ssl_compatibility_level: request.sslCompatibilityLevel,
  tags: request.tags,
  type: request.type,
  ...resolveOneOf([{
    param: 'organization_id',
    value: request.organizationId
  }, {
    param: 'project_id',
    value: request.projectId
  }])
});
const marshalZonedApiCreateRouteRequest = (request, defaults) => ({
  backend_id: request.backendId,
  frontend_id: request.frontendId,
  match: request.match
});
const marshalZonedApiCreateSubscriberRequest = (request, defaults) => ({
  name: request.name,
  ...resolveOneOf([{
    param: 'organization_id',
    value: request.organizationId
  }, {
    param: 'project_id',
    value: request.projectId
  }]),
  ...resolveOneOf([{
    param: 'email_config',
    value: request.emailConfig
  }, {
    param: 'webhook_config',
    value: request.webhookConfig
  }])
});
const marshalZonedApiMigrateLbRequest = (request, defaults) => ({
  type: request.type
});
const marshalZonedApiRemoveBackendServersRequest = (request, defaults) => ({
  server_ip: request.serverIp
});
const marshalZonedApiSetAclsRequest = (request, defaults) => ({
  acls: request.acls
});
const marshalZonedApiSetBackendServersRequest = (request, defaults) => ({
  server_ip: request.serverIp
});
const marshalZonedApiSubscribeToLbRequest = (request, defaults) => ({
  subscriber_id: request.subscriberId
});
const marshalZonedApiUpdateAclRequest = (request, defaults) => ({
  action: request.action,
  description: request.description,
  index: request.index,
  match: request.match,
  name: request.name
});
const marshalZonedApiUpdateBackendRequest = (request, defaults) => ({
  failover_host: request.failoverHost,
  forward_port: request.forwardPort,
  forward_port_algorithm: request.forwardPortAlgorithm,
  forward_protocol: request.forwardProtocol,
  ignore_ssl_server_verify: request.ignoreSslServerVerify,
  max_connections: request.maxConnections,
  max_retries: request.maxRetries,
  name: request.name,
  on_marked_down_action: request.onMarkedDownAction,
  proxy_protocol: request.proxyProtocol,
  redispatch_attempt_count: request.redispatchAttemptCount,
  send_proxy_v2: request.sendProxyV2,
  ssl_bridging: request.sslBridging,
  sticky_sessions: request.stickySessions,
  sticky_sessions_cookie_name: request.stickySessionsCookieName,
  timeout_connect: request.timeoutConnect,
  timeout_queue: request.timeoutQueue,
  timeout_server: request.timeoutServer,
  timeout_tunnel: request.timeoutTunnel
});
const marshalZonedApiUpdateCertificateRequest = (request, defaults) => ({
  name: request.name
});
const marshalZonedApiUpdateFrontendRequest = (request, defaults) => ({
  backend_id: request.backendId,
  certificate_id: request.certificateId,
  certificate_ids: request.certificateIds,
  enable_http3: request.enableHttp3,
  inbound_port: request.inboundPort,
  name: request.name,
  timeout_client: request.timeoutClient
});
const marshalZonedApiUpdateHealthCheckRequest = (request, defaults) => ({
  check_delay: request.checkDelay,
  check_max_retries: request.checkMaxRetries,
  check_send_proxy: request.checkSendProxy,
  check_timeout: request.checkTimeout,
  port: request.port,
  transient_check_delay: request.transientCheckDelay,
  ...resolveOneOf([{
    param: 'http_config',
    value: request.httpConfig
  }, {
    param: 'https_config',
    value: request.httpsConfig
  }, {
    param: 'ldap_config',
    value: request.ldapConfig
  }, {
    param: 'mysql_config',
    value: request.mysqlConfig
  }, {
    param: 'pgsql_config',
    value: request.pgsqlConfig
  }, {
    param: 'redis_config',
    value: request.redisConfig
  }, {
    param: 'tcp_config',
    value: request.tcpConfig
  }])
});
const marshalZonedApiUpdateIpRequest = (request, defaults) => ({
  reverse: request.reverse
});
const marshalZonedApiUpdateLbRequest = (request, defaults) => ({
  description: request.description,
  name: request.name,
  ssl_compatibility_level: request.sslCompatibilityLevel,
  tags: request.tags
});
const marshalZonedApiUpdateRouteRequest = (request, defaults) => ({
  backend_id: request.backendId,
  match: request.match
});
const marshalZonedApiUpdateSubscriberRequest = (request, defaults) => ({
  name: request.name,
  ...resolveOneOf([{
    param: 'email_config',
    value: request.emailConfig
  }, {
    param: 'webhook_config',
    value: request.webhookConfig
  }])
});

export { marshalAddBackendServersRequest, marshalAttachPrivateNetworkRequest, marshalCreateAclRequest, marshalCreateBackendRequest, marshalCreateCertificateRequest, marshalCreateFrontendRequest, marshalCreateIpRequest, marshalCreateLbRequest, marshalCreateRouteRequest, marshalCreateSubscriberRequest, marshalMigrateLbRequest, marshalRemoveBackendServersRequest, marshalSetBackendServersRequest, marshalSubscribeToLbRequest, marshalUpdateAclRequest, marshalUpdateBackendRequest, marshalUpdateCertificateRequest, marshalUpdateFrontendRequest, marshalUpdateHealthCheckRequest, marshalUpdateIpRequest, marshalUpdateLbRequest, marshalUpdateRouteRequest, marshalUpdateSubscriberRequest, marshalZonedApiAddBackendServersRequest, marshalZonedApiAttachPrivateNetworkRequest, marshalZonedApiCreateAclRequest, marshalZonedApiCreateBackendRequest, marshalZonedApiCreateCertificateRequest, marshalZonedApiCreateFrontendRequest, marshalZonedApiCreateIpRequest, marshalZonedApiCreateLbRequest, marshalZonedApiCreateRouteRequest, marshalZonedApiCreateSubscriberRequest, marshalZonedApiMigrateLbRequest, marshalZonedApiRemoveBackendServersRequest, marshalZonedApiSetAclsRequest, marshalZonedApiSetBackendServersRequest, marshalZonedApiSubscribeToLbRequest, marshalZonedApiUpdateAclRequest, marshalZonedApiUpdateBackendRequest, marshalZonedApiUpdateCertificateRequest, marshalZonedApiUpdateFrontendRequest, marshalZonedApiUpdateHealthCheckRequest, marshalZonedApiUpdateIpRequest, marshalZonedApiUpdateLbRequest, marshalZonedApiUpdateRouteRequest, marshalZonedApiUpdateSubscriberRequest, unmarshalAcl, unmarshalBackend, unmarshalCertificate, unmarshalFrontend, unmarshalHealthCheck, unmarshalIp, unmarshalLb, unmarshalLbStats, unmarshalListAclResponse, unmarshalListBackendStatsResponse, unmarshalListBackendsResponse, unmarshalListCertificatesResponse, unmarshalListFrontendsResponse, unmarshalListIpsResponse, unmarshalListLbPrivateNetworksResponse, unmarshalListLbTypesResponse, unmarshalListLbsResponse, unmarshalListRoutesResponse, unmarshalListSubscriberResponse, unmarshalPrivateNetwork, unmarshalRoute, unmarshalSetAclsResponse, unmarshalSubscriber };
