import randomName from '../../../node_modules/.pnpm/@scaleway_random-name@4.0.2/node_modules/@scaleway/random-name/dist/index.js';
import { isJSONObject } from '../../../helpers/json.js';
import { unmarshalDate, unmarshalArrayOfObject } from '../../../helpers/marshalling.js';

// This file was automatically generated. DO NOT EDIT.
// If you have any remark or suggestion do not hesitate to open an issue.
const unmarshalNamespace = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Namespace' failed as data isn't a dictionary.`);
  }
  return {
    createdAt: unmarshalDate(data.created_at),
    endpoint: data.endpoint,
    id: data.id,
    name: data.name,
    projectId: data.project_id,
    protocol: data.protocol,
    region: data.region,
    updatedAt: unmarshalDate(data.updated_at)
  };
};
const unmarshalPermissions = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Permissions' failed as data isn't a dictionary.`);
  }
  return {
    canManage: data.can_manage ? data.can_manage : undefined,
    canPublish: data.can_publish ? data.can_publish : undefined,
    canReceive: data.can_receive ? data.can_receive : undefined
  };
};
const unmarshalCredentialSQSSNSCreds = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'CredentialSQSSNSCreds' failed as data isn't a dictionary.`);
  }
  return {
    accessKey: data.access_key,
    permissions: unmarshalPermissions(data.permissions),
    secretKey: data.secret_key ? data.secret_key : undefined
  };
};
const unmarshalCredentialNATSCredsFile = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'CredentialNATSCredsFile' failed as data isn't a dictionary.`);
  }
  return {
    content: data.content
  };
};
const unmarshalCredential = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'Credential' failed as data isn't a dictionary.`);
  }
  return {
    id: data.id,
    name: data.name,
    namespaceId: data.namespace_id,
    natsCredentials: data.nats_credentials ? unmarshalCredentialNATSCredsFile(data.nats_credentials) : undefined,
    protocol: data.protocol,
    sqsSnsCredentials: data.sqs_sns_credentials ? unmarshalCredentialSQSSNSCreds(data.sqs_sns_credentials) : undefined
  };
};
const unmarshalCredentialSummarySQSSNSCreds = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'CredentialSummarySQSSNSCreds' failed as data isn't a dictionary.`);
  }
  return {
    accessKey: data.access_key,
    permissions: unmarshalPermissions(data.permissions)
  };
};
const unmarshalCredentialSummary = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'CredentialSummary' failed as data isn't a dictionary.`);
  }
  return {
    id: data.id,
    name: data.name,
    namespaceId: data.namespace_id,
    protocol: data.protocol,
    sqsSnsCredentials: data.sqs_sns_credentials ? unmarshalCredentialSummarySQSSNSCreds(data.sqs_sns_credentials) : undefined
  };
};
const unmarshalListCredentialsResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListCredentialsResponse' failed as data isn't a dictionary.`);
  }
  return {
    credentials: unmarshalArrayOfObject(data.credentials, unmarshalCredentialSummary),
    totalCount: data.total_count
  };
};
const unmarshalListNamespacesResponse = data => {
  if (!isJSONObject(data)) {
    throw new TypeError(`Unmarshalling the type 'ListNamespacesResponse' failed as data isn't a dictionary.`);
  }
  return {
    namespaces: unmarshalArrayOfObject(data.namespaces, unmarshalNamespace),
    totalCount: data.total_count
  };
};
const marshalCreateCredentialRequest = (request, defaults) => ({
  name: request.name || randomName('mnq'),
  namespace_id: request.namespaceId,
  permissions: request.permissions
});
const marshalCreateNamespaceRequest = (request, defaults) => ({
  name: request.name || randomName('mnq'),
  project_id: request.projectId ?? defaults.defaultProjectId,
  protocol: request.protocol
});
const marshalUpdateCredentialRequest = (request, defaults) => ({
  name: request.name,
  permissions: request.permissions
});
const marshalUpdateNamespaceRequest = (request, defaults) => ({
  name: request.name,
  namespace_id: request.namespaceId
});

export { marshalCreateCredentialRequest, marshalCreateNamespaceRequest, marshalUpdateCredentialRequest, marshalUpdateNamespaceRequest, unmarshalCredential, unmarshalListCredentialsResponse, unmarshalListNamespacesResponse, unmarshalNamespace };
