/**
 * Validates an unknown object is a JSON Object.
 *
 * @internal
 */
const isJSONObject = obj => {
  const objT = typeof obj;
  return obj !== undefined && obj !== null && objT !== 'string' && objT !== 'number' && objT !== 'boolean' && !Array.isArray(obj) && objT === 'object';
};

export { isJSONObject };
